use Function::Parameters;
use Function::Return;
use Types::Standard -types;
use Test::More tests => 1;

fun Blood() {
    Str & sub { $_ =~ qr!(?:A|B|O)(?:A|B|O)! }
}

# 交配した時の血液型の組み合わせ
fun mate(Blood $a, Blood $b) :Return(ArrayRef[Blood]) {
    my @a = split //, $a;
    my @b = split //, $b;
    [ map {
        my $a = $_;
        map { join '', sort $a, $_ } @b } @a ];
}

is_deeply mate('AO', 'BO'), ['AB', 'AO', 'BO', 'OO'];
