# WEB+DB PRESS Vol.107 連載「Perl Hackers Hub」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.107」の連載「Perl Hackers Hub」第52回「Perlで堅牢な開発」（小林 謙太著）のサンプルコードです。

## 検証環境

- perl 5.28.0
- macOS High Sierra

## 動作に必要な環境

- perl v5.14 以上
    - Function::Paramters の為

### CPANモジュール

サンプルコードの実行には以下のモジュールが必要になります。`cpanm`などでインストールしてください。

- 本文で紹介したモジュール
    - [strictures](https://metacpan.org/pod/strictures)
    - [Type::Tiny](https://metacpan.org/pod/Type::Tiny)
    - [Type::Tie](https://metacpan.org/pod/Type::Tie)
    - [Function::Paramters](https://metacpan.org/pod/Function::Parameters)
    - [Function::Return](https://metacpan.org/pod/Function::Return)
- ベンチマークで比較したモジュール
    - [Smart::Args](https://metacpan.org/pod/Smart::Args)
    - [Smart::Args::TypeTiny](https://metacpan.org/pod/Smart::Args::TypeTiny)
    - [Data::Validator](https://metacpan.org/pod/Data::Validator)
    - [Params::ValidationCompiler](https://metacpan.org/pod/Params::ValidationCompiler)
    - [Params::Validate](https://metacpan.org/pod/Params::Validate)
- その他
    - [Module::Functions](https://metacpan.org/pod/Module::Functions)


## 動作方法

```shell
cd src/
perl -Ilib path/to/file
```

## 注意事項

本文説明の都合、警告ないしエラーになるコードがあります。

- エラー
    - 1_syntax_error.pl
    - 3_strict_refs_example.pl
    - 5_warnings_fatal_example.pl
    - 6_no_warnings.pl
    - 17_function_return_context.pl
    - 18_function_return_option_name.pl
- 警告
    - 4_warnings_example.pl
- 通過しないテストケースが存在
    - 13_prohibit_too_many_args.pl
